.386
.model flat, stdcall
option casemap :none

include windows.inc
include kernel32.inc
include user32.inc
include gdi32.inc

includelib kernel32.lib
includelib user32.lib
includelib gdi32.lib

; #############   ########################################
InitNOINPUTEDITControl proto
NoInputEditProc proto :HWND, :UINT, :DWORD, :DWORD
; #########################################################################

.data

szEdit db"EDIT", 0
szNoInputEdit db "NOINPUTEDIT", 0

.data

lpfnOldEditProc dd ?

.code

; #########################################################################
InitNOINPUTEDITControl proc
  local wc:WNDCLASSEX
  local hInst:HINSTANCE

  invoke GetModuleHandle, NULL
  mov hInst, eax
  ;    "edit"
  mov wc.cbSize, sizeof WNDCLASSEX
  invoke GetClassInfoEx, hInst, addr szEdit, addr wc
  ;  
  push hInst                                    ;  
  pop wc.hInstance
  mov wc.lpszClassName, offset szNoInputEdit    ;   
  push wc.lpfnWndProc                           ;      
  pop lpfnOldEditProc
  mov wc.lpfnWndProc, offset NoInputEditProc
  invoke LoadCursor, NULL, IDC_ARROW            ;  
  mov wc.hCursor, eax
  ;   
  invoke RegisterClassEx, addr wc

  ret

InitNOINPUTEDITControl endp
; #########################################################################
NoInputEditProc proc hEdit:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD

  .if uMsg == WM_CHAR
    ;   
    
  .elseif uMsg == WM_KEYDOWN
    mov eax, wParam
    .if al == VK_LEFT || al == VK_RIGHT || al == VK_HOME || al == VK_END
      invoke CallWindowProc, lpfnOldEditProc, hEdit, uMsg, wParam, lParam
      ret    
    .endif 
  .else
    invoke CallWindowProc, lpfnOldEditProc, hEdit, uMsg, wParam, lParam
    ret
  .endif

  xor eax, eax
  ret

NoInputEditProc endp

end
; #########################################################################
